__gnu_debug::_Safe_iterator_base(3cxx)

NAME
__gnu_debug::_Safe_iterator_base - Basic functionality for a safe iterator.

SYNOPSIS

Inherited by __gnu_debug::_Safe_iterator< _Iterator, _Sequence, std::bidirectional_iterator_tag >, __gnu_debug::_Safe_iterator< _Iterator, _Sequence, std::forward_iterator_tag >, __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >, and __gnu_debug::_Safe_local_iterator_base.

  Public Member Functions

bool _M_attached_to (const _Safe_sequence_base *__seq) const
bool _M_can_compare (const _Safe_iterator_base &__x) const throw ()
void _M_detach_single () throw ()
void _M_invalidate ()
void _M_reset () throw ()
bool _M_singular () const throw ()
void _M_unlink () throw ()

  Public Attributes

_Safe_iterator_base * _M_next
_Safe_iterator_base * _M_prior
_Safe_sequence_base * _M_sequence
unsigned int _M_version

  Protected Member Functions

_Safe_iterator_base ()
_Safe_iterator_base (const _Safe_iterator_base &__x, bool __constant)
_Safe_iterator_base (const _Safe_sequence_base *__seq, bool __constant)
void _M_attach (_Safe_sequence_base *__seq, bool __constant)
void _M_attach_single (_Safe_sequence_base *__seq, bool __constant) throw ()
void _M_detach ()
__gnu_cxx::__mutex & _M_get_mutex () throw ()

  Friends

class _Safe_sequence_base

Detailed Description

Basic functionality for a safe iterator.

The _Safe_iterator_base base class implements the functionality of a safe iterator that is not specific to a particular iterator type. It contains a pointer back to the sequence it references along with iterator version information and pointers to form a doubly-linked list of iterators referenced by the container.

This class must not perform any operations that can throw an exception, or the exception guarantees of derived iterators will be broken.

Constructor & Destructor Documentation

  __gnu_debug::_Safe_iterator_base::_Safe_iterator_base () [inline], [protected]
Initializes the iterator and makes it singular.

  __gnu_debug::_Safe_iterator_base::_Safe_iterator_base (const _Safe_sequence_base * __seq, bool __constant) [inline], [protected]
Initialize the iterator to reference the sequence pointed to by __seq. __constant is true when we are initializing a constant iterator, and false if it is a mutable iterator. Note that __seq may be NULL, in which case the iterator will be singular. Otherwise, the iterator will reference __seq and be nonsingular.

References _M_attach().

  __gnu_debug::_Safe_iterator_base::_Safe_iterator_base (const _Safe_iterator_base & __x, bool __constant) [inline], [protected]
Initializes the iterator to reference the same sequence that __x does. __constant is true if this is a constant iterator, and false if it is mutable.

References _M_attach(), and _M_sequence.

Member Function Documentation

  void __gnu_debug::_Safe_iterator_base::_M_attach (_Safe_sequence_base * __seq, bool __constant) [protected]
Attaches this iterator to the given sequence, detaching it from whatever sequence it was attached to originally. If the new sequence is the NULL pointer, the iterator is left unattached.

Referenced by _Safe_iterator_base(), and __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_attach().

  void __gnu_debug::_Safe_iterator_base::_M_attach_single (_Safe_sequence_base * __seq, bool __constant) [protected]
Likewise, but not thread-safe.

Referenced by __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_attach_single().

  bool __gnu_debug::_Safe_iterator_base::_M_attached_to (const _Safe_sequence_base * __seq) const [inline]
Determines if we are attached to the given sequence.

References _M_sequence.

  bool __gnu_debug::_Safe_iterator_base::_M_can_compare (const _Safe_iterator_base & __x) const
Can we compare this iterator to the given iterator __x? Returns true if both iterators are nonsingular and reference the same sequence.

  void __gnu_debug::_Safe_iterator_base::_M_detach () [protected]
Detach the iterator for whatever sequence it is attached to, if any.

  void __gnu_debug::_Safe_iterator_base::_M_detach_single ()
Likewise, but not thread-safe.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  __gnu_cxx::__mutex& __gnu_debug::_Safe_iterator_base::_M_get_mutex () [protected]
For use in _Safe_iterator.

  void __gnu_debug::_Safe_iterator_base::_M_invalidate () [inline]
Invalidate the iterator, making it singular.

References _M_version.

  void __gnu_debug::_Safe_iterator_base::_M_reset ()
Reset all member variables

  bool __gnu_debug::_Safe_iterator_base::_M_singular () const
Is this iterator singular?

Referenced by __gnu_debug::__check_singular_aux(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_dereferenceable(), __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_dereferenceable(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::_M_incrementable(), and __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_incrementable().

  void __gnu_debug::_Safe_iterator_base::_M_unlink () [inline]
Unlink itself

References _M_next, and _M_prior.

Member Data Documentation

  _Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_next
Pointer to the next iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Referenced by __gnu_debug::_Safe_sequence< _SafeSequence >::_M_invalidate_if(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

  _Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_prior
Pointer to the previous iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Referenced by __gnu_debug::_Safe_sequence< _SafeSequence >::_M_invalidate_if(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

  _Safe_sequence_base* __gnu_debug::_Safe_iterator_base::_M_sequence
The sequence this iterator references; may be NULL to indicate a singular iterator.

Referenced by _Safe_iterator_base(), __gnu_debug::_Safe_local_iterator_base::_Safe_local_iterator_base(), _M_attached_to(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

  unsigned int __gnu_debug::_Safe_iterator_base::_M_version
The version number of this iterator. The sentinel value 0 is used to indicate an invalidated iterator (i.e., one that is singular because of an operation on the container). This version number must equal the version number in the sequence referenced by _M_sequence for the iterator to be non-singular.

Referenced by _M_invalidate(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

Author

Generated automatically by Doxygen for libstdc++ from the source code.